;##################################################################
; TIMER COLOR
;##################################################################

#Define WM_CLOSE 10h
#Define WM_INITDIALOG 110h
#Define WM_COMMAND 111h
#Define WM_TIMER 113h
#Define WM_CTLCOLOREDIT 133h

#Define GWL_USERDATA -21

#Define TRANSPARENT 1
#Define WHITE_BRUSH 0

IDD_DLG1	equ		1000
CID_EDIT	equ		1001

DATA SECTION
	hInstance	DD		?

CODE SECTION

Start:
	invoke GetModuleHandleA, 0
	mov [hInstance],eax
	invoke InitCommonControls
	invoke DialogBoxParamA,[hInstance],IDD_DLG1,0,ADDR DlgProc,0
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam
	uses ebx

	mov eax,[uMsg]
	cmp eax,WM_INITDIALOG
	jne >.WMCOMMAND
		invoke SetTimer,[hwnd],999,5000,0
		invoke GetDlgItem,[hwnd],CID_EDIT
		invoke SetWindowLongA,eax,GWL_USERDATA,0FF0000h
		jmp >>.EXIT

	.WMCOMMAND
	cmp eax,WM_COMMAND
	jne >.WMCTLCOLOREDIT

		jmp >>.EXIT

	.WMCTLCOLOREDIT
	cmp eax, WM_CTLCOLOREDIT
	jne >.WMTIMER
		invoke GetWindowLongA,[lParam],GWL_USERDATA
		invoke SetTextColor,[wParam],eax
		invoke SetBkMode,[wParam],TRANSPARENT
		invoke GetStockObject,WHITE_BRUSH
		ret

	.WMTIMER
	cmp eax,WM_TIMER
	jne >.WMCLOSE
		invoke GetDlgItem,[hwnd],CID_EDIT
		mov ebx,eax
		invoke GetWindowLongA,eax,GWL_USERDATA
		mov ecx,0FF0000h
		test eax,eax
		mov eax,0
		cmovz eax,ecx
		invoke SetWindowLongA,ebx,GWL_USERDATA,eax
		invoke InvalidateRect,ebx, 0, 1
		ret

	.WMCLOSE
	cmp eax,WM_CLOSE
	jne >.DEFPROC
		INVOKE EndDialog,[hwnd], 0

	.DEFPROC
		mov eax, 0
		ret

	.EXIT

	mov eax, 1
	ret
ENDF

